// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.AppEvents {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/appEvents/{id}`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.AppEventResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "appEvents-get_instance")
        }

        public struct GetParameters {
            public var fieldsAppEvents: [FieldsAppEvents]?
            public var include: [Include]?
            public var fieldsAppEventLocalizations: [FieldsAppEventLocalizations]?
            public var limitLocalizations: Int?

            public enum FieldsAppEvents: String, Codable, CaseIterable {
                case app
                case archivedTerritorySchedules
                case badge
                case deepLink
                case eventState
                case localizations
                case primaryLocale
                case priority
                case purchaseRequirement
                case purpose
                case referenceName
                case territorySchedules
            }

            public enum Include: String, Codable, CaseIterable {
                case localizations
            }

            public enum FieldsAppEventLocalizations: String, Codable, CaseIterable {
                case appEvent
                case appEventScreenshots
                case appEventVideoClips
                case locale
                case longDescription
                case name
                case shortDescription
            }

            public init(fieldsAppEvents: [FieldsAppEvents]? = nil, include: [Include]? = nil, fieldsAppEventLocalizations: [FieldsAppEventLocalizations]? = nil, limitLocalizations: Int? = nil) {
                self.fieldsAppEvents = fieldsAppEvents
                self.include = include
                self.fieldsAppEventLocalizations = fieldsAppEventLocalizations
                self.limitLocalizations = limitLocalizations
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(fieldsAppEvents, forKey: "fields[appEvents]")
                encoder.encode(include, forKey: "include")
                encoder.encode(fieldsAppEventLocalizations, forKey: "fields[appEventLocalizations]")
                encoder.encode(limitLocalizations, forKey: "limit[localizations]")
                return encoder.items
            }
        }

        public func patch(_ body: _Specification.AppEventUpdateRequest) -> Request<_Specification.AppEventResponse> {
            Request(method: "PATCH", url: path, body: body, id: "appEvents-update_instance")
        }

        public var delete: Request<Void> {
            Request(method: "DELETE", url: path, id: "appEvents-delete_instance")
        }
    }
}
