// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.AppStoreReviewDetails {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/appStoreReviewDetails/{id}`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.AppStoreReviewDetailResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "appStoreReviewDetails-get_instance")
        }

        public struct GetParameters {
            public var fieldsAppStoreReviewDetails: [FieldsAppStoreReviewDetails]?
            public var include: [Include]?
            public var fieldsAppStoreReviewAttachments: [FieldsAppStoreReviewAttachments]?
            public var limitAppStoreReviewAttachments: Int?

            public enum FieldsAppStoreReviewDetails: String, Codable, CaseIterable {
                case appStoreReviewAttachments
                case appStoreVersion
                case contactEmail
                case contactFirstName
                case contactLastName
                case contactPhone
                case demoAccountName
                case demoAccountPassword
                case demoAccountRequired
                case notes
            }

            public enum Include: String, Codable, CaseIterable {
                case appStoreReviewAttachments
                case appStoreVersion
            }

            public enum FieldsAppStoreReviewAttachments: String, Codable, CaseIterable {
                case appStoreReviewDetail
                case assetDeliveryState
                case fileName
                case fileSize
                case sourceFileChecksum
                case uploadOperations
                case uploaded
            }

            public init(fieldsAppStoreReviewDetails: [FieldsAppStoreReviewDetails]? = nil, include: [Include]? = nil, fieldsAppStoreReviewAttachments: [FieldsAppStoreReviewAttachments]? = nil, limitAppStoreReviewAttachments: Int? = nil) {
                self.fieldsAppStoreReviewDetails = fieldsAppStoreReviewDetails
                self.include = include
                self.fieldsAppStoreReviewAttachments = fieldsAppStoreReviewAttachments
                self.limitAppStoreReviewAttachments = limitAppStoreReviewAttachments
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(fieldsAppStoreReviewDetails, forKey: "fields[appStoreReviewDetails]")
                encoder.encode(include, forKey: "include")
                encoder.encode(fieldsAppStoreReviewAttachments, forKey: "fields[appStoreReviewAttachments]")
                encoder.encode(limitAppStoreReviewAttachments, forKey: "limit[appStoreReviewAttachments]")
                return encoder.items
            }
        }

        public func patch(_ body: _Specification.AppStoreReviewDetailUpdateRequest) -> Request<_Specification.AppStoreReviewDetailResponse> {
            Request(method: "PATCH", url: path, body: body, id: "appStoreReviewDetails-update_instance")
        }
    }
}
