// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.AppStoreVersionExperiments {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/appStoreVersionExperiments/{id}`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.AppStoreVersionExperimentResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "appStoreVersionExperiments-get_instance")
        }

        public struct GetParameters {
            public var fieldsAppStoreVersionExperiments: [FieldsAppStoreVersionExperiments]?
            public var include: [Include]?
            public var fieldsAppStoreVersionExperimentTreatments: [FieldsAppStoreVersionExperimentTreatments]?
            public var limitAppStoreVersionExperimentTreatments: Int?

            public enum FieldsAppStoreVersionExperiments: String, Codable, CaseIterable {
                case appStoreVersion
                case appStoreVersionExperimentTreatments
                case endDate
                case name
                case reviewRequired
                case startDate
                case started
                case state
                case trafficProportion
            }

            public enum Include: String, Codable, CaseIterable {
                case appStoreVersion
                case appStoreVersionExperimentTreatments
            }

            public enum FieldsAppStoreVersionExperimentTreatments: String, Codable, CaseIterable {
                case appIcon
                case appIconName
                case appStoreVersionExperiment
                case appStoreVersionExperimentTreatmentLocalizations
                case name
                case promotedDate
            }

            public init(fieldsAppStoreVersionExperiments: [FieldsAppStoreVersionExperiments]? = nil, include: [Include]? = nil, fieldsAppStoreVersionExperimentTreatments: [FieldsAppStoreVersionExperimentTreatments]? = nil, limitAppStoreVersionExperimentTreatments: Int? = nil) {
                self.fieldsAppStoreVersionExperiments = fieldsAppStoreVersionExperiments
                self.include = include
                self.fieldsAppStoreVersionExperimentTreatments = fieldsAppStoreVersionExperimentTreatments
                self.limitAppStoreVersionExperimentTreatments = limitAppStoreVersionExperimentTreatments
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(fieldsAppStoreVersionExperiments, forKey: "fields[appStoreVersionExperiments]")
                encoder.encode(include, forKey: "include")
                encoder.encode(fieldsAppStoreVersionExperimentTreatments, forKey: "fields[appStoreVersionExperimentTreatments]")
                encoder.encode(limitAppStoreVersionExperimentTreatments, forKey: "limit[appStoreVersionExperimentTreatments]")
                return encoder.items
            }
        }

        public func patch(_ body: _Specification.AppStoreVersionExperimentUpdateRequest) -> Request<_Specification.AppStoreVersionExperimentResponse> {
            Request(method: "PATCH", url: path, body: body, id: "appStoreVersionExperiments-update_instance")
        }

        public var delete: Request<Void> {
            Request(method: "DELETE", url: path, id: "appStoreVersionExperiments-delete_instance")
        }
    }
}
