// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.PromotedPurchases {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/promotedPurchases/{id}`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.PromotedPurchaseResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "promotedPurchases-get_instance")
        }

        public struct GetParameters {
            public var fieldsPromotedPurchases: [FieldsPromotedPurchases]?
            public var include: [Include]?
            public var fieldsPromotedPurchaseImages: [FieldsPromotedPurchaseImages]?
            public var limitPromotionImages: Int?

            public enum FieldsPromotedPurchases: String, Codable, CaseIterable {
                case app
                case enabled
                case inAppPurchaseV2
                case promotionImages
                case state
                case subscription
                case visibleForAllUsers
            }

            public enum Include: String, Codable, CaseIterable {
                case inAppPurchaseV2
                case promotionImages
                case subscription
            }

            public enum FieldsPromotedPurchaseImages: String, Codable, CaseIterable {
                case assetToken
                case assetType
                case fileName
                case fileSize
                case imageAsset
                case promotedPurchase
                case sourceFileChecksum
                case state
                case uploadOperations
                case uploaded
            }

            public init(fieldsPromotedPurchases: [FieldsPromotedPurchases]? = nil, include: [Include]? = nil, fieldsPromotedPurchaseImages: [FieldsPromotedPurchaseImages]? = nil, limitPromotionImages: Int? = nil) {
                self.fieldsPromotedPurchases = fieldsPromotedPurchases
                self.include = include
                self.fieldsPromotedPurchaseImages = fieldsPromotedPurchaseImages
                self.limitPromotionImages = limitPromotionImages
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(fieldsPromotedPurchases, forKey: "fields[promotedPurchases]")
                encoder.encode(include, forKey: "include")
                encoder.encode(fieldsPromotedPurchaseImages, forKey: "fields[promotedPurchaseImages]")
                encoder.encode(limitPromotionImages, forKey: "limit[promotionImages]")
                return encoder.items
            }
        }

        public func patch(_ body: _Specification.PromotedPurchaseUpdateRequest) -> Request<_Specification.PromotedPurchaseResponse> {
            Request(method: "PATCH", url: path, body: body, id: "promotedPurchases-update_instance")
        }

        public var delete: Request<Void> {
            Request(method: "DELETE", url: path, id: "promotedPurchases-delete_instance")
        }
    }
}
