// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.Subscriptions.WithID {
    public var offerCodes: OfferCodes {
        OfferCodes(path: path + "/offerCodes")
    }

    public struct OfferCodes {
        /// Path: `/v1/subscriptions/{id}/offerCodes`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.SubscriptionOfferCodesResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "subscriptions-offerCodes-get_to_many_related")
        }

        public struct GetParameters {
            public var filterTerritory: [String]?
            public var fieldsSubscriptionOfferCodeCustomCodes: [FieldsSubscriptionOfferCodeCustomCodes]?
            public var fieldsSubscriptionOfferCodes: [FieldsSubscriptionOfferCodes]?
            public var fieldsSubscriptionOfferCodeOneTimeUseCodes: [FieldsSubscriptionOfferCodeOneTimeUseCodes]?
            public var fieldsSubscriptions: [FieldsSubscriptions]?
            public var fieldsSubscriptionOfferCodePrices: [FieldsSubscriptionOfferCodePrices]?
            public var limit: Int?
            public var limitOneTimeUseCodes: Int?
            public var limitCustomCodes: Int?
            public var limitPrices: Int?
            public var include: [Include]?

            public enum FieldsSubscriptionOfferCodeCustomCodes: String, Codable, CaseIterable {
                case active
                case createdDate
                case customCode
                case expirationDate
                case numberOfCodes
                case offerCode
            }

            public enum FieldsSubscriptionOfferCodes: String, Codable, CaseIterable {
                case active
                case customCodes
                case customerEligibilities
                case duration
                case name
                case numberOfPeriods
                case offerEligibility
                case offerMode
                case oneTimeUseCodes
                case prices
                case subscription
                case totalNumberOfCodes
            }

            public enum FieldsSubscriptionOfferCodeOneTimeUseCodes: String, Codable, CaseIterable {
                case active
                case createdDate
                case expirationDate
                case numberOfCodes
                case offerCode
                case values
            }

            public enum FieldsSubscriptions: String, Codable, CaseIterable {
                case appStoreReviewScreenshot
                case availableInAllTerritories
                case familySharable
                case group
                case groupLevel
                case introductoryOffers
                case name
                case offerCodes
                case pricePoints
                case prices
                case productID = "productId"
                case promotedPurchase
                case promotionalOffers
                case reviewNote
                case state
                case subscriptionLocalizations
                case subscriptionPeriod
            }

            public enum FieldsSubscriptionOfferCodePrices: String, Codable, CaseIterable {
                case subscriptionPricePoint
                case territory
            }

            public enum Include: String, Codable, CaseIterable {
                case customCodes
                case oneTimeUseCodes
                case prices
                case subscription
            }

            public init(filterTerritory: [String]? = nil, fieldsSubscriptionOfferCodeCustomCodes: [FieldsSubscriptionOfferCodeCustomCodes]? = nil, fieldsSubscriptionOfferCodes: [FieldsSubscriptionOfferCodes]? = nil, fieldsSubscriptionOfferCodeOneTimeUseCodes: [FieldsSubscriptionOfferCodeOneTimeUseCodes]? = nil, fieldsSubscriptions: [FieldsSubscriptions]? = nil, fieldsSubscriptionOfferCodePrices: [FieldsSubscriptionOfferCodePrices]? = nil, limit: Int? = nil, limitOneTimeUseCodes: Int? = nil, limitCustomCodes: Int? = nil, limitPrices: Int? = nil, include: [Include]? = nil) {
                self.filterTerritory = filterTerritory
                self.fieldsSubscriptionOfferCodeCustomCodes = fieldsSubscriptionOfferCodeCustomCodes
                self.fieldsSubscriptionOfferCodes = fieldsSubscriptionOfferCodes
                self.fieldsSubscriptionOfferCodeOneTimeUseCodes = fieldsSubscriptionOfferCodeOneTimeUseCodes
                self.fieldsSubscriptions = fieldsSubscriptions
                self.fieldsSubscriptionOfferCodePrices = fieldsSubscriptionOfferCodePrices
                self.limit = limit
                self.limitOneTimeUseCodes = limitOneTimeUseCodes
                self.limitCustomCodes = limitCustomCodes
                self.limitPrices = limitPrices
                self.include = include
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(filterTerritory, forKey: "filter[territory]")
                encoder.encode(fieldsSubscriptionOfferCodeCustomCodes, forKey: "fields[subscriptionOfferCodeCustomCodes]")
                encoder.encode(fieldsSubscriptionOfferCodes, forKey: "fields[subscriptionOfferCodes]")
                encoder.encode(fieldsSubscriptionOfferCodeOneTimeUseCodes, forKey: "fields[subscriptionOfferCodeOneTimeUseCodes]")
                encoder.encode(fieldsSubscriptions, forKey: "fields[subscriptions]")
                encoder.encode(fieldsSubscriptionOfferCodePrices, forKey: "fields[subscriptionOfferCodePrices]")
                encoder.encode(limit, forKey: "limit")
                encoder.encode(limitOneTimeUseCodes, forKey: "limit[oneTimeUseCodes]")
                encoder.encode(limitCustomCodes, forKey: "limit[customCodes]")
                encoder.encode(limitPrices, forKey: "limit[prices]")
                encoder.encode(include, forKey: "include")
                return encoder.items
            }
        }
    }
}
