// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.Users {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/users/{id}`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.UserResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "users-get_instance")
        }

        public struct GetParameters {
            public var fieldsUsers: [FieldsUsers]?
            public var include: [Include]?
            public var fieldsApps: [FieldsApps]?
            public var limitVisibleApps: Int?

            public enum FieldsUsers: String, Codable, CaseIterable {
                case allAppsVisible
                case firstName
                case lastName
                case provisioningAllowed
                case roles
                case username
                case visibleApps
            }

            public enum Include: String, Codable, CaseIterable {
                case visibleApps
            }

            public enum FieldsApps: String, Codable, CaseIterable {
                case appClips
                case appCustomProductPages
                case appEvents
                case appInfos
                case appStoreVersions
                case availableInNewTerritories
                case availableTerritories
                case betaAppLocalizations
                case betaAppReviewDetail
                case betaGroups
                case betaLicenseAgreement
                case betaTesters
                case builds
                case bundleID = "bundleId"
                case ciProduct
                case contentRightsDeclaration
                case customerReviews
                case endUserLicenseAgreement
                case gameCenterEnabledVersions
                case inAppPurchases
                case inAppPurchasesV2
                case isOrEverWasMadeForKids
                case name
                case perfPowerMetrics
                case preOrder
                case preReleaseVersions
                case pricePoints
                case prices
                case primaryLocale
                case promotedPurchases
                case reviewSubmissions
                case sku
                case subscriptionGracePeriod
                case subscriptionGroups
                case subscriptionStatusURL = "subscriptionStatusUrl"
                case subscriptionStatusURLForSandbox = "subscriptionStatusUrlForSandbox"
                case subscriptionStatusURLVersion = "subscriptionStatusUrlVersion"
                case subscriptionStatusURLVersionForSandbox = "subscriptionStatusUrlVersionForSandbox"
            }

            public init(fieldsUsers: [FieldsUsers]? = nil, include: [Include]? = nil, fieldsApps: [FieldsApps]? = nil, limitVisibleApps: Int? = nil) {
                self.fieldsUsers = fieldsUsers
                self.include = include
                self.fieldsApps = fieldsApps
                self.limitVisibleApps = limitVisibleApps
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(fieldsUsers, forKey: "fields[users]")
                encoder.encode(include, forKey: "include")
                encoder.encode(fieldsApps, forKey: "fields[apps]")
                encoder.encode(limitVisibleApps, forKey: "limit[visibleApps]")
                return encoder.items
            }
        }

        public func patch(_ body: _Specification.UserUpdateRequest) -> Request<_Specification.UserResponse> {
            Request(method: "PATCH", url: path, body: body, id: "users-update_instance")
        }

        public var delete: Request<Void> {
            Request(method: "DELETE", url: path, id: "users-delete_instance")
        }
    }
}
