// Generated by Create API
// https://github.com/CreateAPI/CreateAPI"
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V2.InAppPurchases.WithID {
    public var iapPriceSchedule: IapPriceSchedule {
        IapPriceSchedule(path: path + "/iapPriceSchedule")
    }

    public struct IapPriceSchedule {
        /// Path: `/v2/inAppPurchases/{id}/iapPriceSchedule`
        public let path: String

        public func get(parameters: GetParameters? = nil) -> Request<_Specification.InAppPurchasePriceScheduleResponse> {
            Request(method: "GET", url: path, query: parameters?.asQuery, id: "inAppPurchases-iapPriceSchedule-get_to_one_related")
        }

        public struct GetParameters {
            public var fieldsInAppPurchasePrices: [FieldsInAppPurchasePrices]?
            public var fieldsInAppPurchases: [FieldsInAppPurchases]?
            public var fieldsInAppPurchasePriceSchedules: [FieldsInAppPurchasePriceSchedules]?
            public var limitManualPrices: Int?
            public var include: [Include]?

            public enum FieldsInAppPurchasePrices: String, Codable, CaseIterable {
                case inAppPurchasePricePoint
                case inAppPurchaseV2
                case startDate
                case territory
            }

            public enum FieldsInAppPurchases: String, Codable, CaseIterable {
                case app
                case appStoreReviewScreenshot
                case availableInAllTerritories
                case content
                case contentHosting
                case familySharable
                case iapPriceSchedule
                case inAppPurchaseLocalizations
                case inAppPurchaseType
                case name
                case pricePoints
                case productID = "productId"
                case promotedPurchase
                case reviewNote
                case state
            }

            public enum FieldsInAppPurchasePriceSchedules: String, Codable, CaseIterable {
                case inAppPurchase
                case manualPrices
            }

            public enum Include: String, Codable, CaseIterable {
                case inAppPurchase
                case manualPrices
            }

            public init(fieldsInAppPurchasePrices: [FieldsInAppPurchasePrices]? = nil, fieldsInAppPurchases: [FieldsInAppPurchases]? = nil, fieldsInAppPurchasePriceSchedules: [FieldsInAppPurchasePriceSchedules]? = nil, limitManualPrices: Int? = nil, include: [Include]? = nil) {
                self.fieldsInAppPurchasePrices = fieldsInAppPurchasePrices
                self.fieldsInAppPurchases = fieldsInAppPurchases
                self.fieldsInAppPurchasePriceSchedules = fieldsInAppPurchasePriceSchedules
                self.limitManualPrices = limitManualPrices
                self.include = include
            }

            public var asQuery: [(String, String?)] {
                let encoder = URLQueryEncoder(explode: false)
                encoder.encode(fieldsInAppPurchasePrices, forKey: "fields[inAppPurchasePrices]")
                encoder.encode(fieldsInAppPurchases, forKey: "fields[inAppPurchases]")
                encoder.encode(fieldsInAppPurchasePriceSchedules, forKey: "fields[inAppPurchasePriceSchedules]")
                encoder.encode(limitManualPrices, forKey: "limit[manualPrices]")
                encoder.encode(include, forKey: "include")
                return encoder.items
            }
        }
    }
}
